> module Angabe3 where

1. Vervollstaendigen Sie gemaess Angabentext!
2. Vervollst�ndigen Sie auch die vorgegebenen Kommentaranf�nge!
3. Loeschen Sie keine Deklarationen aus diesem Rahmenprogramm, auch nicht die Modulanweisug!
4. Achten Sie darauf, dass `Gruppe' Leserechte fuer Ihre Abgabedatei hat!

> type Nat1      = Int
> type Zeile     = [Int]

Matrizen konzeptuell als Listen von Zeilen dargestellt:

> newtype Matrix = M [Zeile] deriving (Eq)

> fehlerwert = M [] :: Matrix

> data Matrixtyp = Mat (Nat1,Nat1) | KeineMatrix deriving (Eq,Show)


Aufgabe A.1

> instance Show Matrix where
>   show m = matrixToString m "("

Solution:
    * if the parameter matrix is an empty matrix, return "()"
    * if the current row of the matrix is not empty, but the rest of the matrix is, then add the current row and close the string with ")"
    * otherwise, add the current row to the result and call the function recursively with the rest of the matrix

> matrixToString :: Matrix -> String -> String
> matrixToString matrix res
>   | matrix == fehlerwert = "()"
>   | length m /= 0 && null ms = res ++ show m ++ ")"
>   | otherwise = matrixToString restMatrix (res ++ show m ++ " ")
>   where
>       (M (m:ms)) = matrix
>       restMatrix = (M ms)

Aufgabe A.2

Solution:
    * if the parameter is an empty matrix, then return KeineMatrix
    * check if the parameter is an NM matrix by obtaining the length of the first row and comparing it with each consequitive one. If there is a mismatch, then the matrix is not a NM matrix
    * if the parameter is an NM matrix, return the pair (height, width)

> matrixtyp :: Matrix -> Matrixtyp
> matrixtyp m
>   | m == fehlerwert = KeineMatrix
>   | isCorrectMatrix m 0 == False = KeineMatrix
>   | otherwise = getMatrixType m

> isCorrectMatrix :: Matrix -> Int -> Bool
> isCorrectMatrix matrix n
>   | matrix == fehlerwert = True
>   | n == 0 && length m /= 0 = isCorrectMatrix matrix (length m)
>   | n == length m = isCorrectMatrix (M ms) n
>   | otherwise = False
>   where
>       (M (m:ms)) = matrix

> getMatrixType :: Matrix -> Matrixtyp
> getMatrixType (M (m:ms)) = (Mat (length (m:ms), length m))

Aufgabe A.3

Knapp, aber gut nachvollziebar geht die Instanzdeklaration fuer Eq folgendermassen vor:
...

instance Eq Matrix where
 ...

Aufgabe A.4

Knapp, aber gut nachvollziebar geht die Instanzdeklaration fuer Num folgendermassen vor:
...


instance Num Matrix where
 ...
